package de.dser.pr.presentations.easymock.recipes;

import javax.naming.AuthenticationException;
import java.util.*;

public class CustomerService {
    static final List<String> FIRST_NAMES = Arrays.asList("Kevin", "Peter", "Angela", "William");
    static final List<String> LAST_NAMES = Arrays.asList("Riker", "Mitnick", "Birkenstock", "Picard");
    private final CustomerDAO customerDAO;

    public CustomerService(CustomerDAO customerDAO) {
        this.customerDAO = customerDAO;
    }

    public void changePassword(Long customerId, String oldPassword, String newPassword) throws AuthenticationException {
        Customer customer = customerDAO.read(customerId);

        if (!customer.getPassword().equals(oldPassword))
            throw new AuthenticationException();
        else
            customer.setPassword(newPassword);

        customerDAO.update(customer);
    }

    public void generateNewCustomerCauseWeNeedMoney() {
        Random random = new Random(System.currentTimeMillis());
        String firstName = FIRST_NAMES.get(random.nextInt(3));
        String lastName = LAST_NAMES.get(random.nextInt(3));
        String password = generateInSecurePassword(random);
        customerDAO.create(firstName, lastName, password);
    }

    private String generateInSecurePassword(Random random) {
        StringBuilder passBuilder = new StringBuilder();

        for (int i = 0; i < 8; i++) {
            passBuilder.append(random.nextInt(9));
        }

        return passBuilder.toString();
    }
}
