package de.dser.pr.presentations.easymock.recipes;

import de.dser.pr.presentations.easymock.Condition;
import de.dser.pr.presentations.easymock.SleepingConditionChecker;
import org.easymock.EasyMock;
import org.junit.Test;

public class MockingExceptionsTest {
	@Test(expected = IllegalArgumentException.class)
	public void testExceptionThrowing() throws Exception {
		Condition condition = EasyMock.createMock(Condition.class);
		EasyMock.expect(condition.isConditionMet()).andThrow(new IllegalArgumentException());

		EasyMock.replay(condition);
		try {
			condition.isConditionMet();
		} finally {
			EasyMock.verify(condition);
		}
	}

	@Test(expected = IllegalArgumentException.class)
	public void testExceptionThrowingOfVoidMethods() throws Exception {
		SleepingConditionChecker mock = EasyMock.createMock(SleepingConditionChecker.class);
		mock.sleepUntilConditionMet(null);
		EasyMock.expectLastCall().andThrow(new IllegalArgumentException());

		EasyMock.replay(mock);
		mock.sleepUntilConditionMet(null);
		EasyMock.verify(mock);
	}
}
